﻿(function(Otime){

	Otime.Score	= new function Score(){
//		"use strict";

		var _this	= this;

		_this.name	= "score";

		_this.model	= "";

		_this.language	= null;

		var tmpl	= '<li><a href="javascript:;">${message} (${score})</a></li>';
		var tmplName	= "tmplScore";
		$.template( "tmplScore", '<li><a href="javascript:;">${message} (${score})</a></li>');

		var isScorePopup	= false;
		var showDetails	= function(){
			if (isScorePopup)
			{
				$("#score-list").hide();
				isScorePopup	= false;
			}
			else
			{
				$.get(Otime.siteUrl + "/score/details", {
					date: new Date().format("YYYY-MM-DD 00:00:00")
				}, function(resp){
					if (resp[0] && resp[2] && resp[2].score && resp[2].score.otvalues)
					{
						var scoreList	= $("#score-list");
						scoreList.html("");

						resp	= resp[2].score;

						resp.otvalues.setKeys(resp.otkeys, function(item){
							switch(item.acode)
							{
								case 'TEHN':
									item.message	= 'You not estimate for 7hrs before 11:30 AM';
									$.tmpl("tmplScore", item).appendTo(scoreList);
									break;
								case 'WHNU':
									item.message	= 'Worked Hours not Updated till lunch';
									$.tmpl("tmplScore", item).appendTo(scoreList);
									break;
								case 'TFEH':
									item.message	= 'Task Finished within Estimated hours with Actual Hours more than 8';
									$.tmpl("tmplScore", item).appendTo(scoreList);
									break;
								case 'TNFE':
									item.message	= 'Task NOT Finished within Estimated hours with Actual Hours more than 8';
									$.tmpl("tmplScore", item).appendTo(scoreList);
									break;
								case 'TBS':
									item.message	= 'More then 1hr worked in bugfix task';
									$.tmpl("tmplScore", item).appendTo(scoreList);
									break;
								case 'TFM':
									item.message	= 'Task Finished within Milestone';
									$.tmpl("tmplScore", item).appendTo(scoreList);
									break;
								case 'TNFM':
									item.message	= 'Task Not finished within Milestone';
									$.tmpl("tmplScore", item).appendTo(scoreList);
									break;
							}
						});
						scoreList.show();
						isScorePopup	= true;
					}
				});
			}
		};

		_this.init	= function(){
			$.get(Otime.siteUrl + "/score/my_scores", {
			}, function(resp){
				if (resp[0] && resp[2])
				{
					resp	= resp[2];
					var scoreDisp	= resp.score.score ? resp.score.score + '/' : '';
					scoreDisp	+= resp.total_score.score;
					var content	= '<span class="score h3 nm cp">' + scoreDisp +  '</span><ul id="score-list" class="dropdown-menu"></ul>';
					$("#score").html(content);
					$("#score").click(function(){
						showDetails();
					});
				}
			});
		};
	};
}(window.Otime));
