<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$on_premises_license_url	= 'http://www.outputtime.com/index.php/on-premises-register/';	
?>
<div class="row nm">
	<div class="form-horizontal" data-bind="with:otherDetails">
		<div class="form-group nmlr">
			<h3><?php echo lang('STEP4_0')?></h3>
			<h4><?php echo lang('STEP4_1')?></h4>
		</div>
		<div class="form-group nmlr">
			<label for="email" class="col-sm-4 control-label"><?php echo lang('STEP4_EMAIL')?> *</label>
			<div class="col-sm-6">
				<input type="text" class="form-control" tabindex="1" data-bind="value:email" id="email" placeholder="<?php echo lang('STEP4_EMAIL')?>" name="email" value="email" maxlength="80" />
			</div>
		</div>
		<div class="form-group nmlr">
			<label for="password" class="col-sm-4 control-label"><?php echo lang('STEP4_PASSWORD')?> *</label>
			<div class="col-sm-6">
				<input type="password" class="form-control" tabindex="2" data-bind="value:password" id="password" placeholder="<?php echo lang('STEP4_PASSWORD')?>" name="password" value="" maxlength="12" minlength="6" />
			</div>
		</div>
		<div class="form-group nmlr">
			<label for="confirm_password" class="col-sm-4 control-label"><?php echo lang('STEP4_CONFIRM_PASSWORD')?> *</label>
			<div class="col-sm-6">
				<input type="password" class="form-control" tabindex="3" data-bind="value:confirm_password" id="confirm_password" placeholder="<?php echo lang('STEP4_CONFIRM_PASSWORD')?>" name="confirm_password" value="" maxlength="12" minlength="6" />
			</div>
		</div>
		<div class="form-group nmlr">
			<label for="first_name" class="col-sm-4 control-label"><?php echo lang('STEP4_FIRST_NAME')?> *</label>
			<div class="col-sm-6">
				<input type="text" class="form-control" tabindex="4" data-bind="value:first_name" id="first_name" placeholder="<?php echo lang('STEP4_FIRST_NAME')?>" name="first_name" value="" maxlength="40" minlength="4">
			</div>
		</div>
		<div class="form-group nmlr">
			<label for="last_name" class="col-sm-4 control-label"><?php echo lang('STEP4_LAST_NAME')?>&nbsp;&nbsp;</label>
			<div class="col-sm-6">
				<input type="text" class="form-control" tabindex="5" data-bind="value:last_name" id="last_name" placeholder="<?php echo lang('STEP4_LAST_NAME')?>" name="database_name" value="" maxlength="40">
			</div>
		</div>
		<div class="form-group nmlr">
			<label for="license_key" class="col-sm-4 control-label"><?php echo lang('STEP4_LICENSE_KEY')?> *</label>
			<div class="col-sm-6">
				<input type="text" class="form-control" tabindex="6" data-bind="value:license_key" id="license_key" placeholder="<?php echo lang('STEP4_LICENSE_KEY')?>" name="license_key" value="">
				<span style="display: inline-block; padding: 10px 0px;"><?php echo lang('GET_LICENSE_HERE'); ?> : <a target="blank" href="<?php echo $on_premises_license_url; ?>"><?php echo $on_premises_license_url; ?></a></span>
			</div>
		</div>
		<div class="form-group nmlr">
			<div class="col-sm-4">
			</div>
			<div class="col-sm-6">
				<input type="button" data-bind="click:$parent.prev" tabindex="8" class="btn btn-success btn-big" value="Previous" />
				<input type="button" data-bind="click:$parent.next" tabindex="7" class="btn btn-success btn-big pull-right" value="Next" />
			</div>
		</div>
	</div>
</div>
